const EVANGELIZE_STRING = '<p style="font-size: smaller;">Edited with <a href="http://composite.mozdev.org">Composite</a></p>';
const EVANGELIZE_REGEX = /<p\s+style="font-size:\s+smaller;">Edited\s+with\s+<a\s+href="http:\/\/composite.mozdev.org">Composite<\/a><\/p>/m

var compositeEditor;
var textareaHandle;
var originalValue;

function Init() {
  setCompositeDefaultPrefs();

  window.title = "Editing " +  opener.getBrowser().contentDocument.title;

  textareaHandle = window.arguments[0];
  originalValue = textareaHandle.value; /* save to prevent dataloss */

  compositeEditor = new Editor("content-frame", "content-source", "editor-deck", textareaHandle.value);
}

function compositeSave() {
  if (textareaHandle.value != originalValue) {
    /* user changed textarea underneath us */
    if (!confirm("The textarea you are editing has been modified, do you want to overwrite it's contents?"))
      return;
  }

  var content = compositeEditor.content;

  if (getPref().GetBoolPref(PREF_EVANGELIZE) && 
    !EVANGELIZE_REGEX.test(content))
      content += EVANGELIZE_STRING;

  if (getPref().GetBoolPref(PREF_STRIP_HTML_LINEBREAK))
    content = content.replace(/<br(\s\/)?>/gm, "");

  if (getPref().GetBoolPref(PREF_STRIP_CRLF_LINEBREAK))
    content = content.replace(/\r\n/gm, "");

  textareaHandle.value = content;
  opener.closeWindowForTextarea(textareaHandle);
}

function compositeClose() {
  opener.closeWindowForTextarea(textareaHandle);
}

