const PREF_CID = "@mozilla.org/preferences;1";
const nsIPref = Components.interfaces.nsIPref;

var gPreferences;

function getPref() {
  if (!gPreferences) {
    try {
      gPreferences = Components.classes[PREF_CID].getService();
      gPreferences = gPreferences.QueryInterface(nsIPref);
    } catch (e) {
      dump("composite: Error in getPref(): " + e + "\n");
    }
  }

  return gPreferences;
}

/* --- prefs --- */

/* strip <br> */
const PREF_STRIP_HTML_LINEBREAK = "composite.strip_br";

/* strip \r\n */
const PREF_STRIP_CRLF_LINEBREAK = "composite.strip_crlf";

/* disable the textarea while editing */
/* disable the textarea while editing */
const PREF_DISABLE_TEXTAREA = "composite.disable_textarea";

/* add a button to edit textareas */
const PREF_USE_BUTTON = "composite.use_button";

/* use ctrl-e keypress to edit textareas */
const PREF_USE_KEYPRESS = "composite.use_keypress";

/* evangelize Composite */
const PREF_EVANGELIZE = "composite.evangelize";

/* pulled from editor prefs */
const PREF_EDITOR_PRETTYPRINT = "editor.prettyprint";

function setCompositeDefaultPrefs() {
  var pref = getPref();

  pref.SetDefaultBoolPref(PREF_STRIP_HTML_LINEBREAK, false);
  pref.SetDefaultBoolPref(PREF_STRIP_CRLF_LINEBREAK, true);
  pref.SetDefaultBoolPref(PREF_USE_KEYPRESS, true);
  pref.SetDefaultBoolPref(PREF_USE_BUTTON, false);
  pref.SetDefaultBoolPref(PREF_DISABLE_TEXTAREA, false);
  pref.SetDefaultBoolPref(PREF_EVANGELIZE, false);
}
